class MVue{
    constructor(options){
        this.$el = options.el;
        this.$data = options.data;
        this.$options = options;
        if(this.$el){
            // 1实现数据观察者
            // 2实现指令解析器
            new Compile(this.$el,this);
        }
    }
}
class Compile{
    constructor(el,vm){
        this.el = this.isElementNode(el) ? el : document.querySelector(el);
        this.vm = vm;
        // 获取文档碎片对象 放入内存中减少页面回流重绘
        const fragment = this.node2Fragment(this.el);
        // console.dir(fragment);

        // 编译
        this.compile(fragment);

        this.el.appendChild(fragment);
    }
    isElementNode(node){
        return node.nodeType === 1;
    }
    node2Fragment(el){
        const f = document.createDocumentFragment();
        let firstChild;
        while(firstChild = el.firstChild){
            f.appendChild(firstChild);
        }
        return f;
    }
    compile(fragment){
        const childNodes = fragment.childNodes;
        childNodes.forEach(child => {
            // console.log(child);
            if(this.isElementNode(child)){
                // console.log('元素节点',child)
                this.compileElement(child)
            }
            else{
                // console.log('文本节点',child)
                this.compileText(child)
            }
            if(child.childNodes && child.childNodes.length){
                this.compile(child);
            }
        })
    }
    compileElement(node){
        const attributes = node.attributes;
        console.log(attributes);
        [...attributes].forEach(item => {
            const {name,value} = item;
            if(this.isDirective(name)){
                console.log(name);
                const [,vDirective] = name.split('-');
                const [dirName,eventName] = vDirective.split(':'); //on:click
                compileUtil[dirName](node,this.vm,value,eventName)
            }
        })
    }
    compileText(node){

    }

    isDirective(attrName){
        return attrName.startsWith('v-');
    }
}
const compileUtil = {
    text(node,vm,dataKey){
        this.updater.textUpdater(node,vm.$data[dataKey])
    },
    html(node,vm,dataKey){

    },
    model(node,vm,dataKey){

    },
    on(node,vm,dataKey,eventName){

    },
    updater:{
        textUpdater(node,value){
            node.textContent = value;
        }
    }
}